void draw()
{
  // refresh the canvas everyframe
  background(255);
  //modifying the cell size according to window size

  translate( -width/2, -height/2);   // Peasycam intially sets lookAt() at (0,0,0) hence we need to transalte the axis

  if (controlP5.window(this).isMouseOver()) 
  {
    cam.setActive(false);
  } else 
  {
    cam.setActive(true);
  }

  // create base lines  
  //fill(255, 192);

  // creating grid lines in 3D

  //  if ( lineFlag)
  //  {
  //    stroke(64, 128);
  //    for ( int i =0; i <= blockWidth * (numWeekdays); i+= blockWidth)
  //    {
  //      pushMatrix();                                                  //setting up a matrix to keep the current graphi coordinates
  //      translate(constantMarginOnRows, constantMarginOnColumns);      //translate to the correct position
  //      line( i, 0, 0, i, blockHeight * (numWeeks-1), 0);              //creating a line (x,y,z)
  //      popMatrix();                                                   // going back to previos projection matrix
  //    }           
  //    for ( int i = 0; i < blockHeight* numWeeks; i+= blockHeight)
  //    {
  //      pushMatrix();
  //      translate(constantMarginOnRows, constantMarginOnColumns); 
  //      line ( 0, i, 0, blockWidth* numWeekdays, i, 0);
  //      popMatrix();
  //    }
  //  }
  //

  //displaying the cells                        
  //for ( int d = numDewey-1; d>=0; d--) {
  for ( int d = 0; d<numDewey; d++) {
    if (d == deweySelect) {//case layer is selected
      alpha = 255;
    } else { //standard setting common for all other layers
      alpha = transparency;
    }
    for ( int  i = 0; i<  numWeeks; i++) //numWeeks
    {
      for ( int  j = 0; j < numWeekdays; j++)           // -1 as the last column is empty, our dataMatrix is smaller than the table by one column
      {

        if ( dataAwake[i][j][1]!=0)
        {
          noStroke();
          colorMode(HSB);

          //draw inner box  
          pushMatrix();                                                          // doing the same for all the boxes, sadly that is the only way to do this
          fill(1, 192, 224* dataAwake[i][j][d]/maxAwake, alpha);//, 224* dataAwake[i][j]/maxAwake );

          translate(constantMarginOnRows, constantMarginOnColumns);              // translating coordiantes

            factDepth = (float)(dataLatestCout[i][j][d]-dataEarliestCout[i][j][d])/24;//hours dependent scaling factor for depth

          morningShift = (float)(((dataLatestCout[i][j][d]+dataEarliestCout[i][j][d])/2)-12)/24 * blockHeight;

          //int zTranslation = (dataAwake[1][1]*255/ maxAwake);//(dataAwake[i][j]*255/ maxAwake)* 3;
          //translate( blockWidth/2  , blockHeight/2   , i*numWeekdays*blockHeight + j*blockHeight + morningShift);
          translate( i* blockWidth + blockWidth/2 - xPos*blockWidth  + d*pWidth*blockWidth, j* blockHeight + blockHeight/2 + morningShift + yPos* blockHeight + d*pHeight*blockHeight, 1 + zPos*blockDepth - d*pDepth*blockDepth);     // translating coordiantes to box position     
          //data cube only:
          //translate( i* blockWidth + blockWidth/2 - xPos*blockWidth , j* blockHeight + blockHeight/2 + morningShift + yPos* blockHeight, 1 + zPos*blockDepth - d*blockDepth);     // translating coordiantes to box position     

          // note the movement in x position, it is half of the box's x length, this is because the box is drawn at the center
          //box( blockWidth, blockHeight, (dataMatrix[i][j])* 3  );                                    // creating a cube of appropriate size 
          box( blockWidth, blockHeight*factDepth, blockDepth);   

          // d*pDepth*blockDepth
          // ==> d*pDepth*blockDepth

            // floating boxes instad of bar graphs

          // drawing text over the boxes
          if ( numberFlag)
          {
            // box values
            translate( 0, 0, blockDepth/2 + 2 );     // translating coordinates to box position                      
            textFont(myHelvetica16);
            textAlign(CENTER, CENTER);
            fill(0);       
            text( dataAwake[i][j][d], 0, 0  );
          }

          popMatrix();

          //draw outer glass box  
          pushMatrix(); 
          stroke(120);
          strokeWeight(1);
          //colorMode(RGB); 
          fill(1, 1, 224, 0);//, 224* dataAwake[i][j]/maxAwake );
          translate(constantMarginOnRows, constantMarginOnColumns);
          translate( i* blockWidth + blockWidth/2 - xPos*blockWidth  + d*pWidth*blockWidth, j* blockHeight + blockHeight/2 + yPos* blockHeight + d*pHeight*blockHeight, 1 + zPos*blockDepth - d*pDepth*blockDepth);     // translating coordiantes to box position     
          //translate( i* blockWidth + blockWidth/2 - xPos*blockWidth  , j* blockHeight + blockHeight/2 + yPos* blockHeight, 1 + zPos*blockDepth - d*blockDepth);     // translating coordiantes to box position     
          box( blockWidth, blockHeight, blockDepth);   

          if (textFlag) {
            if (d == 0 || d == numDewey-1) { //label only first and last dimension...
              if (i==0) {//case first week of the year ==> write labels on left side of matrix
                translate( -1*blockWidth, 0, blockDepth/2 + 2 );     // translating coordinates to box position                      
                textFont(myHelvetica20);
                textAlign(RIGHT, CENTER);
                fill(66); 
                text(weekdayNames[j], 0, 0 );
                if (j == numWeekdays-1) { //case January
                  translate( blockWidth, blockHeight, blockDepth/2 + 2 );     // translating coordinates to box position                         
                  textFont(myHelvetica20);
                  textAlign(CENTER, CENTER);
                  fill(66); 
                  text("January", 0, 0 );
                }
              } else if (i == 22 & j == 0 & d!=0) { // case title
                translate(0, -2*blockHeight, blockDepth/2 + 2 );
                textFont(myHelvetica24);
                textAlign(CENTER, CENTER);
                fill(66);
                text( "Awake: Empirical hours of a library - across multiple, adjustable dimensions (darker colors refer to longer awake times)", constantMarginOnRows, constantMarginOnColumns/2 );
              } else if ((i ==numWeeks-1) & (j == numWeekdays-1)) { // case December
                translate( 0, blockHeight, blockDepth/2 + 2 );     // translating coordinates to box position                      
                textFont(myHelvetica20);
                textAlign(CENTER, CENTER);
                fill(66); 
                text("December", 0, 0 );
              }
            }
          }
          popMatrix();
        }
      }
    }
  }

  drawGUI();
}      // end of draw

